using Gtk;
using System;

namespace Dizzy
{


	public class FileTreeView
	{
		
		// La treeview passataci dalla grafica
		Gtk.TreeView tree;
		
		// Le colonne che ci servono
		Gtk.TreeViewColumn filenameColumn;
		Gtk.TreeViewColumn userColumn;
		Gtk.TreeViewColumn sizeColumn;
		
		// La listStore per memorizzare i file
		// che troviamo. 
		Gtk.ListStore fileListStore;

		public FileTreeView (Gtk.TreeView tree)
		{
			// Costruisco la ListStore e popolo di colonne
			// la TreeView
			this.tree = tree;
			this.filenameColumn = new Gtk.TreeViewColumn ();
			filenameColumn.Title = "Nome del file";
		
						
			this.userColumn = new Gtk.TreeViewColumn ();
			userColumn.Title = "Utente";
			
			this.sizeColumn = new Gtk.TreeViewColumn ();
			sizeColumn.Title = "Dimensione";
			sizeColumn.Resizable = true;
			
			this.tree.AppendColumn (filenameColumn);
			this.tree.AppendColumn (sizeColumn);
			this.tree.AppendColumn (userColumn);
				
			this.fileListStore = new Gtk.ListStore (typeof(string), // Nome del file
			                                        typeof(string), // Utente
				                                    typeof(string), // Path del file
			                                        typeof(string));// Dimensione
			
			this.tree.Model = fileListStore;
			CellSetup ();
			
		}
		
		protected void CellSetup()
		{
			lock (this) {
				// Filename
				Gtk.CellRendererText filenameRenderer = new Gtk.CellRendererText ();
				filenameColumn.Resizable = true;
				filenameColumn.PackStart (filenameRenderer, true);
				filenameColumn.AddAttribute (filenameRenderer, "text", 0);
				
				// Dimensione
				Gtk.CellRendererText sizeRenderer = new Gtk.CellRendererText ();
				sizeColumn.PackStart (sizeRenderer, true);
				sizeColumn.AddAttribute (sizeRenderer, "text", 3);
				
				// Utente
				Gtk.CellRendererText userRenderer = new Gtk.CellRendererText ();
				userColumn.Resizable = true;
				userColumn.PackStart (userRenderer, true);
				userColumn.AddAttribute (userRenderer, "text", 1);
			}
		}
		
		public void AddFile(Dizzy.File file)
		{
			lock (this) {
				// Aggiungo i valori effettivi nel liststore.
				fileListStore.AppendValues(	file.name, 
			                           		file.user,
			                           		file.path,
				                           	file.SizeToString ());
			}
		}
		
		public void Clear ()
		{
			lock (this) {
				fileListStore.Clear ();
			}
		}
		
		
		public File GetFileFromPath (TreePath path)
		{
			TreeIter iter = new TreeIter ();
			fileListStore.GetIter(out iter, path);
			File f = new File((string) fileListStore.GetValue(iter, 2),
			                  (string) fileListStore.GetValue(iter, 1));
			return f;
		}
		
	}
}
